#!/bin/bash

TOR_TMP_FILE=/home/bogdan/torbox
TOR_EMAIL_FILE=/home/bogdan/tor-tr-allow-addresses

# -----
# save the message to a temporary file:
cat > $TOR_TMP_FILE

# -----
# verify the sender address here, for example with grep, giving it
# a file with a list of allowed e-mail addresses:

FROM_ADDR=`formail -c -x 'From: ' < $TOR_TMP_FILE`

echo $FROM_ADDR | grep -f $TOR_EMAIL_FILE
if ([ $? -ne 0 ]); then
	rm -f $TOR_TMP_FILE
	exit;
fi

# -----
# extract the filename from the subject and the file contents from the body:

# The Subject header must be of form "Tor path/to/file.po"
FILENAME=`formail -c -x 'Subject: ' < $TOR_TMP_FILE | awk '{print $2}'`
DIR=`dirname $FILENAME`
FILE=`basename $FILENAME`

# set IFS just in case - we need the contents in lines, not in one long line
IFS='
'
BODY=`formail -I "" < $TOR_TMP_FILE`
IFS=' '

# -----
# verify file contents:

echo $BODY | msgfmt --statistics -c -o /dev/null -
if ([ $? -ne 0 ]); then
	rm -f $TOR_TMP_FILE
	exit;
fi

# -----
# save the file contents:

# TODO: check for lock here and lock if possible
mkdir -p $DIR
echo $BODY > $FILENAME
# TODO: unlock here

# -----
# remove the temporary file:
rm -f $TOR_TMP_FILE

